# -*- coding: utf-8 -*-
'''
Praktikum 15, lahendused
Viimati uuendatud 9.12.2024.

Kui sul on kõrge resolutsiooniga kuvar. Sisesta konsooli:
%config InlineBackend.figure_format='retina'
'''
#%% ül 1
import numpy as np
import matplotlib.pyplot as plt
# PEP 8 soovitab importida alati mooduli alguses ja mitte klassi seest.

class FuncData:

    def __init__(self, func, x1, x2, dx):
        self.x1 = x1
        self.x2 = x2
        self.dx = dx
        self.x = np.arange(self.x1, self.x2, self.dx)
        self.fdata = func(self.x)

    def __repr__(self):
        return f'objekt: andmed vahemikul [{self.x1}, {self.x2}]'
        
    def graph_func(self, save_file=False):
        plt.plot(self.x, self.fdata, '.-', label="$f(x)$")
        
        plt.xlabel('$x$')
        plt.ylabel('$f(x)$')
        plt.title('Funktsioon $f(x)$')
        plt.legend(loc=0)
        if save_file:
            plt.savefig('ul1_plot1.pdf')
        
        plt.show()
        
    def graph_Dfunc(self, save_file=False):
        Df = np.gradient(self.fdata, self.dx)  # Numbriline tuletis.
        
        plt.plot(self.x, Df, label="$f'(x)$")
        
        plt.xlabel('$x$')
        plt.ylabel("$f'(x)$")
        plt.title("Funktsiooni tuletis $f'(x)$")
        plt.legend(loc=0)
        
        if save_file:
            plt.savefig('ul1_plot2.pdf')
        
        plt.show()

    def graph_DDfunc(self, save_file=False):
        Df = np.gradient(self.fdata, self.dx)  # Numbriline tuletis.
        DDf = np.gradient(Df, self.dx)  # Numbriline teine tuletis.
        
        plt.plot(self.x, DDf, label="$f''(x)$")
        
        plt.xlabel('$x$')
        plt.ylabel("$f''(x)$")
        plt.title("Funktsiooni teine tuletis $f''(x)$")
        plt.legend(loc=0)
        
        if save_file:
            plt.savefig('ul1_plot3.pdf')
        
        plt.show()
        
    def graph_all(self, save_file=False):
        plt.plot(self.x, self.fdata, '.-', label='$f(x)$')
        
        Df = np.gradient(self.fdata, self.dx)  # Numbriline tuletis.
        plt.plot(self.x, Df, label="$f'(x)$")
        
        DDf = np.gradient(Df, self.dx)  # Numbriline teine tuletis.
        plt.plot(self.x, DDf, label="$f''(x)$")
        
        plt.title('Funktsioon $f(x)$ ja selle tuletised')
        plt.xlabel('$x$')
        plt.ylabel("$f(x)$, $f'(x)$, $f''(x)$")
        plt.legend(loc=0)
        
        if save_file:
            plt.savefig('ul1_plot4.pdf')
        
        plt.show()
        

def my_func(x):
    return np.exp(-x ** 2)  

data = FuncData(my_func, -5, 5, 0.2)

data.graph_func()
data.graph_Dfunc()
data.graph_DDfunc()
data.graph_all()


#%% ül 1, Teine lahendus.
import numpy as np
import matplotlib.pyplot as plt

class FuncData:

    def __init__(self, func, x1, x2, dx):
        self.x1 = x1
        self.x2 = x2
        self.dx = dx
        self.x = np.arange(self.x1, self.x2, self.dx)
        self.fdata = func(self.x)
        self.Df = np.gradient(self.fdata, self.dx)  # Numbriline tuletis.
        self.DDf = np.gradient(self.Df, self.dx)  # Numbriline teine tuletis.

    def __repr__(self):
        return f'objekt: andmed vahemikul [{self.x1}, {self.x2}]'
        
    def graph_func(self, save_file=False):
        fig, ax = plt.subplots()  # Joonise ja teljepaari loomine.
        
        ax.plot(self.x, self.fdata, '.-', label='$f(x)$')
        ax.set(xlabel='$x$',
               ylabel="$f(x)$",
               title="Funktsioon $f(x)$")
        ax.legend(loc=0)
        
        if save_file:
            fig.savefig('ul1_plot1.pdf')
            
        plt.show()
        
    def graph_Dfunc(self, save_file=False):
        fig, ax = plt.subplots()  # Joonise ja teljepaari loomine.
        
        ax.plot(self.x, self.Df, label="$f'(x)$")
        ax.set(xlabel='$x$',
               ylabel="$f'(x)$",
               title="Funktsiooni tuletis $f'(x)$")
        ax.legend(loc=0)
        
        if save_file:
            fig.savefig('ul1_plot2.pdf')
            
        plt.show()

    def graph_DDfunc(self, save_file=False):
        fig, ax = plt.subplots()
        
        ax.plot(self.x, self.DDf, label="$f'(x)$")
        ax.set(xlabel='$x$',
               ylabel="$f''(x)$",
               title="Funktsiooni teine tuletis $f''(x)$")
        ax.legend(loc=0)
        
        if save_file:
            fig.savefig('ul1_plot3.pdf')
            
        plt.show()
        
    def graph_all(self, save_file=False):
        fig, ax = plt.subplots()
        ax.plot(self.x, self.fdata, '.-')
        ax.plot(self.x, self.Df)
        ax.plot(self.x, self.DDf)
        ax.set(xlabel='$x$',
               ylabel="$f(x)$, $f'(x)$, $f''(x)$",
               title='Funktsioon $f(x)$ ja selle tuletised')
        if save_file:
            fig.savefig('ul1_plot4.pdf')
        plt.show()
        

def my_func(x):
    return np.exp(-x ** 2)

data = FuncData(my_func, -5, 5, 0.2)

data.graph_func()
data.graph_Dfunc()
data.graph_DDfunc()
data.graph_all()


#%% ül 1, Kolmas lahendus, liigsed muutuja self eemaldatud.
import numpy as np
import matplotlib.pyplot as plt

class FuncData:

    def __init__(self, func, x1, x2, dx):
        self.x = np.arange(x1, x2, dx)
        self.fdata = func(self.x)
        self.Df = np.gradient(self.fdata, dx)  # Numbriline tuletis.
        self.DDf = np.gradient(self.Df, dx)  # Numbriline teine tuletis.

    def __repr__(self):
        return f'{FuncData.__name__} objekt.'  # Ei viitsinud.
        
    def graph_func(self, save_file=False):
        fig, ax = plt.subplots()  # Joonise ja teljepaari loomine.
        ax.plot(self.x, self.fdata, '.-')
        ax.set(xlabel='$x$',
               ylabel="$f(x)$",
               title="Funktsioon $f(x)$")
        if save_file:
            fig.savefig('ul1_plot1.pdf')
        plt.show()
        
    def graph_Dfunc(self, save_file=False):
        fig, ax = plt.subplots()  # Joonise ja teljepaari loomine.
        ax.plot(self.x, self.Df)
        ax.set(xlabel='$x$',
               ylabel="$f'(x)$",
               title="Funktsiooni tuletis $f'(x)$")
        if save_file:
            fig.savefig('ul1_plot2.pdf')
        plt.show()

    def graph_DDfunc(self, save_file=False):
        fig, ax = plt.subplots()  # Joonise ja teljepaari loomine.
        ax.plot(self.x, self.DDf)
        ax.set(xlabel='$x$',
               ylabel="$f''(x)$",
               title="Funktsiooni teine tuletis $f''(x)$")
        if save_file:
            fig.savefig('ul1_plot3.pdf')
        plt.show()
        
    def graph_all(self, save_file=False):
        fig, ax = plt.subplots()  # Joonise ja teljepaari loomine.
        ax.plot(self.x, self.fdata, '.-')
        ax.plot(self.x, self.Df)
        ax.plot(self.x, self.DDf)
        ax.set(xlabel='$x$',
               ylabel="$f(x)$, $f'(x)$, $f''(x)$",
               title='Funktsioon $f(x)$ ja selle tuletised')
        if save_file:
            fig.savefig('ul1_plot4.pdf')
        plt.show()
        

def my_func(x):
    return np.exp(-x ** 2)

data = FuncData(my_func, -5, 5, 0.2)

data.graph_func()
data.graph_Dfunc()
data.graph_DDfunc()
data.graph_all()


#%% ül 2
import numpy as np

# Kontrollin tõesust.
print(np.log(1 + 2 + 3) == np.log(1) + np.log(2) + np.log(3))

print(np.log(1 * 2 * 3) == np.log(1 + 2 + 3) == np.log(1) + np.log(2) + np.log(3))

# Teine alus, ikka tõene:
print(np.log10(1 + 2 + 3) == np.log10(1) + np.log10(2) + np.log10(3))

# Vastus: Juhus. Erand. 


#%% ül 3
import numpy as np

a = np.arange(30, 0, -1).reshape(6, 5)

# Kopeerime:
b = a.copy()  # b = a juhul oleks sama objekt.

# Kontrollin kas on koopia:
print(id(a), id(b), '\nErinev objekt:', id(a) != id(b))
print()

# Asendam numbreid:
b[b%3!=0] = 666  # või 616

# Prinding konsooli:
print(a)
print()
print(b)


#%% ül 3, Teine lahend.
import numpy as np

a = np.arange(30, 0, -1).reshape(6, 5)

# Kopeerime:
b = np.arange(30, 0, -1).reshape(6, 5)

# Kontrollin kas on koopia:
print(id(a), id(b), '\nErinev objekt:', id(a) != id(b))
print()

# Asendam numbreid:
b[b%3!=0] = 666  # või 616

# Prinding konsooli:
print(a)
print()
print(b)


#%% ül 3, Kolmas lahend.
import numpy as np

a = np.arange(30, 0, -1).reshape(6, 5)

# Kopeerime:
b = a[:, :]  # b = a juhul oleks sama objekt.

# Kontrollin kas on koopia:
print(id(a), id(b), '\nErinev objekt:', id(a) != id(b))
print()

# Asendam numbreid:
b[b%3!=0] = 666  # või 616

# Prinding konsooli:
print(a)
print()
print(b)


#%% ül 4
import numpy as np

a = np.arange(30, 0, -1).reshape(6, 5)

paaris_arvud = a[a%2==0]  # Paarisarvud.
print(paaris_arvud)  

summa = np.sum(paaris_arvud)

print('Paarisarvude summa =', summa)


#%% ül 4, Teine lahendus.
import numpy as np

a = np.arange(30, 0, -1).reshape(6, 5)

print(a[a%2 == 0])  # Paarisarvud.

summa = a[a%2 == 0].sum()
print('Paarisarvude summa =', summa)


#%% ül 5
import matplotlib.pyplot as plt
import numpy as np

A = 1
B = 1
a = 5
b = 4
d = np.pi / 5

t = np.linspace(0, 6, 300)

x = A * np.sin(a * t + d)
y = B * np.sin(b * t)

plt.plot(x, y)

plt.xlabel('$x$')
plt.ylabel('$y$')
plt.title(f'Lissajous muster kus $a/b =${a / b}.')

#plt.savefig('test.pdf')
plt.show()


#%% ül 5, Teine lahend.
import matplotlib.pyplot as plt
import numpy as np

def x(A, a, d, t):
    return A * np.sin(a * t + d)

def y(B, b, t):
    return B * np.sin(b * t)

A = 1
B = 1
a = 5
b = 4
d = np.pi / 5

t = np.linspace(0, 6, 300)

plt.plot(x(A, a, d, t), y(B, b, t))

plt.xlabel('$x$')
plt.ylabel('$y$')
plt.title(f'Lissajous muster kus $a/b =${a / b}')

#plt.savefig('test.pdf')
plt.show()


#%% ül 5, Kolmas lahend.
import matplotlib.pyplot as plt
import numpy as np

def x(A, a, d, t):
    return A * np.sin(a * t + d)

def y(B, b, t):
    return B * np.sin(b * t)

A = 1
B = 1
a = 5
b = 4
d = np.pi/5

t = np.linspace(0, 6, 300)

fig, ax = plt.subplots()

ax.plot(x(A, a, d, t), y(B, b, t))
ax.set(xlabel='$x$',   # Telgede konfigureerimine.
       ylabel='$y$',
       title=f'Lissajous muster kus $a/b =${a / b}')

#fig.savefig('test.pdf')
plt.show()


#%% ül 6
import matplotlib.pyplot as plt
import numpy as np

A = 1
B = 1
a = 5
b = 4
d = np.pi / 5

t = np.linspace(0, 7, 300)
x = A * np.sin(a * t + d)
y = B * np.sin(b * t)


fig, axes = plt.subplots(2, 2)

axes[0, 0].plot(x, y)
axes[0, 0].set(xlabel='$x(t)$', 
               ylabel='$y(t)$', 
               title='Kõver $(x(t), y(t))$')

axes[0, 1].plot(t, y)
axes[0, 1].set(xlabel='Parameeter $t$', 
               ylabel='$y(t)$', 
               title='Komponent $y(t)$')

axes[1, 0].plot(x, t)
axes[1, 0].set(xlabel='$x(t)$', 
               ylabel='Parameeter $t$', 
               title='Komponent $x(t)$')

axes[1, 1].remove()  # Teljepaari eemaldamine.

fig.suptitle('Lissajous kõver')
fig.tight_layout()
#fig.savefig('test.png', dpi=180)

plt.show()


#%% ül 6, Teine lahend.
import matplotlib.pyplot as plt
import numpy as np

def x(A, a, d, t):
    return A * np.sin(a * t + d)

def y(B, b, t):
    return B * np.sin(b * t)

A = 1
B = 1
a = 5
b = 4
d = np.pi / 5

t = np.linspace(0, 7, 300)


fig, axes = plt.subplots(2, 2)

axes[0, 0].plot(x(A, a, d, t), y(B, b, t))
axes[0, 0].set(xlabel='$x(t)$', 
               ylabel='$y(t)$', 
               title='Kõver $(x(t), y(t))$')

axes[0, 1].plot(t, y(B, b, t))
axes[0, 1].set(xlabel='Parameeter $t$', 
               ylabel='$y(t)$', 
               title='Komponent $y(t)$')

axes[1, 0].plot(x(A, a, d, t), t)
axes[1, 0].set(xlabel='$x(t)$', 
               ylabel='Parameeter $t$', 
               title='Komponent $x(t)$')

axes[1, 1].remove()

fig.tight_layout()
#fig.savefig('test.pdf')

plt.show()


#%% ül 7
import matplotlib.pyplot as plt
import numpy as np

t = np.linspace(0, 0.1, 400)
f = 50  #[Hz] Sagedus.
omega = 50 * 2 * np.pi  #[rad/s] Ringsagedus (Hz --> rad/s).

faas1 = np.sin(omega * t)
faas2 = np.sin(omega * t + 2 * np.pi / 3)  # Faasinihe on kolmandik perioodi.
faas3 = np.sin(omega * t + 4 * np.pi / 3)

plt.plot(t, faas1)
plt.plot(t, faas2)
plt.plot(t, faas3)
plt.plot(t, faas1 + faas2 + faas3, lw=2, label='Summa')

plt.legend(loc=2)
plt.ylabel('Normeeritud pinge $U$ [1]')
plt.xlabel('Aeg $t$ [s]')

plt.show()


#%% ül 7, Teine lahend.
import matplotlib.pyplot as plt
import numpy as np

t = np.linspace(0, 0.1, 400)
f = 50  #[Hz] Sagedus.
omega = 50 * 2 * np.pi  #[rad/s] Ringsagedus (Hz --> rad/s).

faas1 = np.sin(omega * t)
faas2 = np.sin(omega * t + 2 * np.pi / 3)  # Faasinihe on kolmandik perioodi.
faas3 = np.sin(omega * t + 4 * np.pi / 3)


fig, ax = plt.subplots()  # Joonise ja telgede loomine.

ax.plot(t, faas1)
ax.plot(t, faas2)
ax.plot(t, faas3)
ax.plot(t, faas1 + faas2 + faas3, lw=3, label='Summa')

ax.set(xlabel = 'Aeg $t$ [s]',
       ylabel = 'Normeeritud pinge $U$ [1]')
ax.legend(loc=2)

plt.show()


#%% ül 8
import matplotlib.pyplot as plt
import numpy as np

def suu(x, vsiire):
    p = 0.5 * x**2 + vsiire
    return p

# Ring, pea.
theta = np.linspace(0, 2*np.pi, 100)
r = 1.9
xr = r * np.cos(theta)
yr = r * np.sin(theta)

# Silmad
xs = np.array([-0.91, 0.91])  # = [-0.91, 0.91]
ys = np.array([2, 2])         # = [2, 2]

# x-telg andmed.
x = np.linspace(-1, 1, 30)


fig, (ax1, ax2) = plt.subplots(2, 1, sharex=True)

ax1.scatter(xs, ys)
ax1.plot(x, suu(x, -0.3), 'k-')
ax1.plot(xr, yr + 1, 'k-')
ax1.set(xlim=(-2, 2),
        ylim=(-1, 3),
        aspect=1,  # Aspect ratio.
        title='Emotsioonid')

ax2.plot(xs, ys, 'o')
ax2.plot(x, -suu(x, -0.6), 'k-')
ax2.plot(xr, yr + 1, 'k-')
ax2.set(xlim=(-2, 2),
        ylim=(-1, 3),
        aspect=1)

#fig.savefig('test.pdf')

plt.show()


#%% ül 8, Teine lahend.
import matplotlib.pyplot as plt
import numpy as np

def suu(x, vsiire):
    p = 0.5 * x**2 + vsiire
    return p

# Ring, pea.
theta = np.linspace(0, 2*np.pi, 100)
r = 1.9
xr = r*np.cos(theta)
yr = r*np.sin(theta)

# Silmad.
xs = np.array([-0.91, 0.91])
ys = np.array([2, 2])

# x-telg andmed.
x = np.linspace(-1, 1, 30)


fig, axes = plt.subplots(2, 1, sharex=True)

axes[0].scatter(xs, ys)
axes[0].plot(x, suu(x, -0.3), 'k-')
axes[0].plot(xr, yr + 1, 'k-')
axes[0].set(xlim=(-2, 2),
            ylim=(-1, 3),
            aspect=1,
            title='Emotsioonid')

axes[1].plot(xs, ys, 'o')
axes[1].plot(x, -suu(x, -0.6), 'k-')
axes[1].plot(xr, yr + 1, 'k-')
axes[1].set(xlim=(-2, 2),
            ylim=(-1, 3),
            aspect=1)

#fig.savefig('test.pdf')

plt.show()


#%% ül 9, Osa 1. Kasutades matplotlib.pyplot.hist.
import numpy as np
import matplotlib.pyplot as plt

n_bins = 50  # Histogrammi vahemike (bins) arv.
lw = 0.05  # Graafiku kõverate paksus.

data = np.random.rand(30_000)


fig, (ax1, ax2) = plt.subplots(1, 2)

ax1.plot(data, 'k-', lw=lw)
ax1.set(xlabel='Massiivi indeks $i$',
        ylabel='Andmepunkti väärtus',
        title='Andmed')

ax2.hist(data, bins=n_bins, histtype='step', log=False)
ax2.set(xlabel='Andmepunkti väärtus',
        ylabel='Sündmust väärtuste vahemiku kohta',
        title='Histogramm')

fig.tight_layout()
#fig.savefig('test.png', dpi=180)

plt.show()


#%% ül 9, Osa 2. Kasutades funktsiooni np.histogram.
import numpy as np
import matplotlib.pyplot as plt

n_bins = 50  # Histogrammi vahemike (bins) arv.
lw = 0.05  # Graafiku kõverate paksus.
data = np.random.rand(30_000)

hist = np.histogram(data, bins=n_bins)

fig, (ax1, ax2) = plt.subplots(1, 2)

ax1.plot(data, 'k-', lw=lw)
ax1.set(xlabel='Massiivi indeks $i$',
        ylabel='Andmepunkti väärtus',
        title='Andmed')

ax2.plot(hist[1][1:], hist[0], '.-', lw=0.5)
ax2.set(xlabel='Andmepunkti väärtus',
        ylabel='Sündmust väärtuste vahemiku kohta',
        title='Histogramm',
        ylim=(0, 700))  # Selleks, et oleks selgemalt sirgust näha.

fig.tight_layout()
#fig.savefig('test.png', dpi=180)

plt.show()


#%% ül 10, Osa 1. Integraator on scipy.integrate.cumulative_tapezoid
import numpy as np
import matplotlib.pyplot as plt
from scipy.integrate import cumulative_trapezoid

n = 30  # Mitu tsüklit tehakse.
xn = 50  # Mitu andmepunkti x-telje kohta.
lai = 20  # Algse funktsiooni laiuse parameeter, suurem arv kitsam kelluke.

# Algne funktsioon.
x = np.linspace(-1, 1, num=xn)
fx = np.exp(-lai * x**2)  # Algse funktsiooni väärtused.

# Integreerimise ja tuletiste võtmise tsükkel.
DFx = fx
max_erin = np.array([0])  # Alguses on erinevus null.
for i in np.arange(n):
    Fx = cumulative_trapezoid(DFx, x, initial=0)  # Kumulatiivne integraal.
    DFx = np.gradient(Fx, x)  # Kumulatiivse integraali tuletis.
    erin = DFx - fx
    absmax = np.abs(erin).max()
    max_erin = np.append(max_erin, absmax)

# Joonise loomine.
plt.rcParams['figure.figsize'] = [6.5, 6.0]  # Joonise suurus.

fig, (ax1, ax2, ax3) = plt.subplots(3, 1)

ax1.plot(x, fx, '.-', lw=0.8, label='Algne funk. $f_0(x)$')
ax1.plot(x, Fx, '-', label='Integraal $F(x)$')
ax1.plot(x, DFx, '-', label='Tuletis $f(x)$')
ax1.legend(loc=0)
ax1.set(xlabel='Argument $x$',
        ylabel='$f_0(x)$, $f(x)$, $F(x)$',
        title=f'Funktsioonide graafikud: Peale $n =${n} tsüklit.')

ax2.plot(x, erin, '.-')
ax2.set(xlabel='Argument $x$',
        ylabel='$f(x) - f_0(x)$',
        title=f'Erinevus: Peale $n =${n} tsüklit.')

ax3.plot(max_erin, '.-')
ax3.set(xlabel='Tsükli arv $n$',
        ylabel='Max. erinevus',
        title='Maksimaalne erinevus tsükli kohta')

fig.tight_layout()
#fig.savefig('test.png', dpi=180)
plt.show()

plt.rcParams.update(plt.rcParamsDefault)


#%% ül 10, Osa 2. Integraator on scipy.integrate.cumulative_simpson.
import numpy as np
import matplotlib.pyplot as plt
from scipy.integrate import cumulative_simpson

n = 30  # Mitu tsüklit tehakse.
xn = 50  # Mitu andmepunkti x-telje kohta.
lai = 20  # Algse funktsiooni laiuse parameeter, suurem arv kitsam kelluke.

# Algne funktsioon.
x = np.linspace(-1, 1, num=xn)
fx = np.exp(-lai * x**2)  # Algse funktsiooni väärtused.

# Integreerimise ja tuletiste võtmise tsükkel.
DFx = fx
max_erin = np.array([0])  # Alguses on erinevus null.
for i in np.arange(n):
    Fx = cumulative_simpson(DFx, x=x, initial=0)  # Kumulatiivne integraal.
    DFx = np.gradient(Fx, x)  # Kumulatiivse integraali tuletis.
    erin = DFx - fx
    absmax = np.abs(erin).max()
    max_erin = np.append(max_erin, absmax)

# Joonise loomine.
plt.rcParams['figure.figsize'] = [6.5, 6.0]  # Joonise suurus.

fig, (ax1, ax2, ax3) = plt.subplots(3, 1)

ax1.plot(x, fx, '.-', lw=0.8, label='Algne funk. $f_0(x)$')
ax1.plot(x, Fx, '-', label='Integraal $F(x)$')
ax1.plot(x, DFx, '-', label='Tuletis $f(x)$')
ax1.legend(loc=0)
ax1.set(xlabel = 'Argument $x$',
        ylabel = '$f_0(x)$, $f(x)$, $F(x)$',
        title = f'Funktsioonide graafikud: Peale $n =${n} tsüklit.')

ax2.plot(x, erin, '.-')
ax2.set(xlabel = 'Argument $x$',
        ylabel = '$f(x) - f_0(x)$',
        title = f'Erinevus: Peale $n =${n} tsüklit.')

ax3.plot(max_erin, '.-')
ax3.set(xlabel = 'Tsükli arv $n$',
        ylabel = 'Max. erinevus',
        title = 'Maksimaalne erinevus tsükli kohta')

fig.tight_layout()
#fig.savefig('test.png', dpi=180)
plt.show()

plt.rcParams.update(plt.rcParamsDefault)


#%% ül 10, Teine lahendus. Mõlemad integraatorid kokku pandud samasse faili.
import numpy as np
import matplotlib.pyplot as plt
from scipy.integrate import cumulative_trapezoid
from scipy.integrate import cumulative_simpson

integraator = 0 # 0 = cumulative_trapezoid; 1 = cumulative_simpson.
n = 30  # Mitu tsüklit tehakse.
xn = 50  # Mitu andmepunkti x-telje kohta.
lai = 20  # Algse funktsiooni laiuse parameeter, suurem arv kitsam kelluke.

# Algne funktsioon.
x = np.linspace(-1, 1, num=xn)
fx = np.exp(-lai * x**2)  # Algse funktsiooni väärtused.

# Integreerimise ja tuletiste võtmise tsükkel.
DFx = fx
max_erin = np.array([0])  # Alguses on erinevus null.

def valitud_meetod(data, x):
    if integraator:
        return cumulative_simpson(DFx, x=x, initial=0)
    else:
        return cumulative_trapezoid(data, x, initial=0)

for i in np.arange(n):
    Fx = valitud_meetod(DFx, x)  # Kumulatiivne integraal.
    DFx = np.gradient(Fx, x)  # Kumulatiivse integraali tuletis.
    erin = DFx - fx
    absmax = np.abs(erin).max()
    max_erin = np.append(max_erin, absmax)

# Joonise loomine.
plt.rcParams['figure.figsize'] = [6.5, 6.0]  # Joonise suurus.

fig, (ax1, ax2, ax3) = plt.subplots(3, 1)

ax1.plot(x, fx, '.-', lw=0.8, label='Algne funk. $f_0(x)$')
ax1.plot(x, Fx, '-', label='Integraal $F(x)$')
ax1.plot(x, DFx, '-', label='Tuletis $f(x)$')
ax1.legend(loc=0)
ax1.set(xlabel='Argument $x$',
        ylabel='$f_0(x)$, $f(x)$, $F(x)$',
        title=f'Funktsioonide graafikud: Peale $n =${n} tsüklit.')

ax2.plot(x, erin, '.-')
ax2.set(xlabel= 'Argument $x$',
        ylabel='$f(x) - f_0(x)$',
        title=f'Erinevus: Peale $n =${n} tsüklit.')

ax3.plot(max_erin, '.-')
ax3.set(xlabel='Tsükli arv $n$',
        ylabel='Max. erinevus',
        title='Maksimaalne erinevus tsükli kohta')

fig.tight_layout()
#fig.savefig('test.png', dpi=180)
plt.show()

plt.rcParams.update(plt.rcParamsDefault)


#%% ül 11
import numpy as np
import matplotlib.pyplot as plt
from urllib.request import urlretrieve
from pathlib import Path

def save_fail_kursuse_kodulehelt(fname):
    my_file_obj = Path(fname)
    if my_file_obj.is_file():
        print("Fail on juba töökaustas...")
    else:
        url = f"https://www.tud.ttu.ee/web/dmitri.kartofelev/YFX0500/{fname}"
        urlretrieve(url, fname)
        print("Fail alla laetud töökausta...")

server_file_name = "Kuu.csv"
d_kustuta = 45  # Kraatri maksimaalne diameeter.
n_bins = 10  # Histogrammi bins arv.

save_fail_kursuse_kodulehelt(server_file_name)  # Laeb faili töökausta.

data = np.loadtxt(server_file_name,  # Loen faili andmed sisse.
                  delimiter=',',
                  skiprows=1,
                  unpack=False,
                  usecols=(-2, -1))

data_sorted = data[data[:, 1].argsort()]

vanus = data_sorted[:, 1]  # Kraatrite vanus.
d = data_sorted[:, 0]  # Diameeter.

i_list = []  # Pythoni list. Võid kasutada ka np.array.
print('Kustutatud kraatrite diameetrid:', end=' ')
for i in range(len(d)):
    if d[i] > d_kustuta:
        print(d[i], end=', ')
        i_list.append(i)
print(f'Kokku kustutati {len(i_list)} andmepunkti.')

vanus = np.delete(vanus, i_list)  # Kustutamine indeksite järgi.
d = np.delete(d, i_list)  # Kustutamine indeksite järgi.

hist = np.histogram(d, bins=n_bins)

# Joonise ja graafikute loomine.
plt.rcParams['figure.figsize'] = [10.1, 3.5]
fig, (ax1, ax2, ax3) = plt.subplots(1, 3, sharex=False)

lw = 0.5
ax1.plot(vanus, d, '.k-', lw=lw)
ax1.set(xlabel='Vanus [$10^6$ aastat]',
        ylabel='Kraatri diameeter $d$ [km]',
        title='Kuu kraatri vanus ja diameeter')

ax2.plot(d, '.k-', lw=lw)
ax2.set(xlabel='Massiivi indeks $i$ [1]',
        ylabel='Kraatri diameeter $d$ [km]',
        title='Ühtluse sammuga vanused')

ax3.loglog(hist[1][1:], hist[0], '.k-', lw=lw)  # Saab ka hist[1][:-1].
#ax3.hist(d, bins=n_bins, histtype='step', log=True)  # Matplotlib histogramm.
ax3.set(xlabel='Kraatri diameeter $d$ [km]',
        ylabel='Kraatrit diameetri $d$ kohta [km${}^{-1}$]',
        title='Histogramm')

fig.tight_layout()
#fig.savefig('test.png', dpi=180)

plt.show()

plt.rcParams.update(plt.rcParamsDefault)


#%% ül 12
import numpy as np
from scipy.integrate import quad

func = lambda x: np.exp(-x ** 2)

lahend, err = quad(func, -np.inf, np.inf)

print(lahend)

print('\nTäpne lahend:', np.sqrt(np.pi))
print('Erinevus lahendist =', lahend - np.sqrt(np.pi))


#%% ül 12, Teine lahend.
import numpy as np
from scipy.integrate import quad

def func(x):
    return np.exp(-x ** 2)

lahend, err = quad(func, -np.inf, np.inf)

print(lahend)

print('\nTäpne lahend:', np.sqrt(np.pi))
print('Erinevus lahendist =', lahend - np.sqrt(np.pi))


#%% ül 13
import numpy as np
import matplotlib.pyplot as plt
from scipy.optimize import minimize_scalar

f = lambda x: 5*x**6 - 3*x**5 + 23*x**3 + (x + 1)**2

res = minimize_scalar(f, method='brent')

print(res.x)

x = np.linspace(-4, 4, 300)

plt.plot(x, f(x))
plt.plot(res.x, f(res.x), 'o')  # Lahend.

plt.xlabel('$x$')
plt.ylabel('$f(x)$')

plt.show()


#%% ül 14, Kasutades scipy.optimize.root.
import numpy as np
import matplotlib.pyplot as plt
from scipy.optimize import root

def func1(x): 
    return -0.1 * x

def func2(x): 
    return np.sin(x)

def findIntersection(fun1, fun2, x0):
    tul = root(lambda x: fun1(x) - fun2(x), x0)
    return tul.x

tulem = np.array([])

for x0 in np.arange(-6, 6, 0.8):
    result = findIntersection(func1, func2, x0)
    tulem = np.append(tulem, result)

tulem = np.unique(tulem.round(decimals=10))  # Kordused eemaldatakse.
print('x koordinaadid on:', tulem)

x = np.linspace(-6, 6, 300)

plt.plot(x, func1(x), label='$y_1(x)$')
plt.plot(x, func2(x), label='$y_2(x)$')
plt.plot(tulem, func1(tulem), 'ro')

plt.xlabel('Argument $x$')
plt.ylabel('Funktsioonid $y_1(x)$ ja $y_2(x)$')
plt.legend(loc=0)

#plt.savefig('test.png', dpi=180)
plt.savefig('ul14.png', dpi=180)
plt.show()


#%% ül 14, Kasutades scipy.optimize.fsolve.
import numpy as np
import matplotlib.pyplot as plt
from scipy.optimize import fsolve

def func1(x): 
    return -0.1 * x

def func2(x): 
    return np.sin(x)

def findIntersection(fun1, fun2, x0):
    return fsolve(lambda x: fun1(x) - fun2(x), x0)

tulem = np.array([])

for x0 in np.arange(-6, 6, 0.8):
    result = findIntersection(func1, func2, x0)
    tulem = np.append(tulem, result)

tulem = np.unique(tulem.round(decimals=10))
print('x koordinaadid on:', tulem)

x = np.linspace(-6, 6, 300)

plt.plot(x, func1(x))
plt.plot(x, func2(x))
plt.plot(tulem, func1(tulem), 'ro')

plt.xlabel('$x$')
plt.ylabel('$y_1(x)$ ja $y_2(x)$')

plt.show()


#%% ül 15
from matplotlib.image import imread
import matplotlib.pyplot as plt
import numpy as np
from scipy.signal import convolve

img = imread('fig_L15.tiff')  # 0 = Must, 255 = Maksimaalne intensiivsus.
print('Pildi kuju:', img.shape)  # Massiivi axsis=2 kanalid: Red, Green, Blue, alpha.
print('Pildi andmete andmetüüp on', img.dtype)  # Unsigned 8-bit integers.
img = img[:, :, 0].astype(np.float32)  # Kasuta ühte kanalit (alpha ei sobi).

ker = imread('ker_L15.tiff')
print('Tuuma kuju:', ker.shape)  # Massiivi axsis=2 kanalid: Red, Green, Blue, alpha.
print('Tuuma andmete andmetüüp on', ker.dtype)  # Unsigned 8-bit integers.
ker = ker[:, :, 0].astype(np.float32)

conv = convolve(img, ker, mode='same')
max_coord = np.unravel_index(np.argmax(conv), conv.shape)
print('Leitud maksimumi indeksid (i, j) =', max_coord)

# Joonise loomine.
fig, ax = plt.subplots(2, 2)  # Joonis kus 2 rida ja 2 veergu teljepaare.

ax[0, 0].imshow(img)
ax[0, 0].set(xlabel='Piksli indeks $j$',
             ylabel='Piksli indeks $i$',
             title='Originaal')

ax[0, 1].imshow(ker)
ax[0, 1].set(xlabel='Piksli indeks $j$',
             ylabel='Piksli indeks $i$',
             title='Tuum')

ax[1, 0].imshow(conv)
ax[1, 0].plot(max_coord[1], max_coord[0], 'r+')
ax[1, 0].set(xlabel='Piksli indeks $j$',
             ylabel='Piksli indeks $i$',
             title='Konvolutsioon')

ax[1, 1].remove()  # Eemaldab teljepaari jooniselt.

fig.suptitle('Pildifaili analüüs')
fig.tight_layout() 
#fig.savefig('test.png', dpi=180)

plt.show()


#%% ül 16
from scipy.signal import convolve
import matplotlib.pyplot as plt
import numpy as np

def make_data(lai, x_n=100, y_n=100, x_dom=5, y_dom=5, x_nihe=0, y_nihe=0):
    '''Funktsioon make_data loob andmed.
    lai -> Kui lai on objekt joonisel. Mida suurem number seda väiksem.
    x_n -> Mitu andmepunkti x-domeenis.
    y_n -> Mitu andmepunkti y-domeenis.
    x_dom -> x-domeeni suurus x in [-x_dom, x_dom]
    y_dom -> y-domeeni suurus y in [-y_dom, y_dom]
    x_nihe -> Objekti nihe punkti O=(x, y)=(0, 0) suhtes x-telje suunas.
    y_nihe -> Objekti nihe punkti O=(x, y)=(0, 0) suhtes y-telje suunas.
    '''
    x = np.linspace(-x_dom, x_dom, x_n)
    y = np.linspace(-y_dom, y_dom, y_n)
    xx, yy = np.meshgrid(x, y)  # Loome andmemassiivi kuju.
    z = np.exp(-lai*((xx - x_nihe)**2 + (yy - y_nihe)**2))  # Loome massiivi.
    return x, y, z

# Originaali andmed.
orig = make_data(0.2, x_dom=5, y_dom=4, x_nihe=2, y_nihe=-1)

# Tuuma andmed.
ker = make_data(0.2, x_n=20, y_n=20, x_dom=1, y_dom=1)  # Väiksem kui originaal.

# Konvolutsioon.
conv = convolve(orig[2], ker[2], mode='same')
max_index = np.unravel_index(np.argmax(conv), conv.shape)
max_coord = (orig[0][max_index[1]], orig[1][max_index[0]])
print('Leitud asukoha koordinaat (x, y) =', max_coord)

# Joonise loomine.
fig, ax = plt.subplots(2, 2)  # Joonis kus 2 rida ja 2 veergu teljepaare.

ax[0, 0].contourf(*orig, levels=100)
ax[0, 0].set(xlabel='Koordinaat $x$',
             ylabel='Koordinaat $y$',
             title='Originaal')

ax[0, 1].contourf(*ker, levels=100)
ax[0, 1].set(xlabel='Koordinaat $x$',
             ylabel='Koordinaat $y$',
             title='Tuum')

ax[1, 0].contourf(orig[0], orig[1], conv, levels=100)
ax[1, 0].plot(*max_coord, 'r+')
ax[1, 0].set(xlabel='Koordinaat $x$',
             ylabel='Koordinaat $y$',
             title='Konvolutsioon')

ax[1, 1].contour(orig[0], orig[1], conv, linewidths=0.75, levels=15)
ax[1, 1].plot(*max_coord, 'r+')
ax[1, 1].set(xlabel='Koordinaat $x$',
             ylabel='Koordinaat $y$',
             title='Konvolutsioon')

fig.suptitle('Massiivi andmete analüüs')
fig.tight_layout()
#fig.savefig('test.png', dpi=180)

plt.show()


#%% ül 17
from matplotlib.image import imsave
import matplotlib.pyplot as plt
import numpy as np

def make_image_data(lai, j_n=200, i_n=200, j_nihe=0, i_nihe=0):
    '''Funktsioon make_image_data loob andmed.
    lai -> Kui lai on objekt joonisel. Mida suurem number seda väiksem.
    x_n -> Mitu andmepunkti j-domeenis.
    y_n -> Mitu andmepunkti i-domeenis.
    j_nihe -> Objekti nihe O=(0, 0) suhtes j-telje pos. suunas vahemikul [-1,1].
    i_nihe -> Objekti nihe O=(0, 0) suhtes i-telje pos. suunas vahemikul [-1,1].
    '''
    j = np.linspace(-1, 1, j_n)
    i = np.linspace(-1, 1, i_n)
    jj, ii = np.meshgrid(j, i)  # Loome andmemassiivi kuju.
    andmed = np.exp(-lai*((jj - j_nihe)**2 + (ii - i_nihe)**2))
    print('Indeksite tõlgendus: (j, i) = (horisontaalne telg, vertikaalne telg)')
    return andmed

def save_8bit_image(fname, dat):
    '''Salvestab kaks pilti töökausta.
    fname: str
        Loodavate failide failinimede tüvi.
    dat: numpy.ndarray
        2D massiiv mis sisaldab pildi andmeid.
    '''
    # Normeerime vahemikku [0,256]. Andmetüüp np.uint8 (unsigned 8-bit integer).
    img8bit = (((dat - dat.min())/(dat.max() - dat.min()))*255.9).astype(np.uint8)
    # Salvestamine:
    # Õige värv: 0=must ja 256=max intensiivsus, valge.
    imsave(f'{fname}.tiff', img8bit, cmap='gray')
    # Negatiiv.
    imsave(f'{fname}_neg.tiff', img8bit, cmap='Grays')
    return True

def view_data(dat):
    # Joonise loomine.
    fig, ax = plt.subplots()
    
    ax.imshow(dat)
    ax.set(xlabel = 'Piksli indeks $j$',
           ylabel = 'Piksli indeks $i$',
           title = 'Andmed $\\to$ pilt')
    
    fig.tight_layout()
    #fig.savefig('test.png', dpi=180)
    plt.show()

img_data = make_image_data(1, j_n=450, i_n=300, j_nihe=-0.75, i_nihe=0.25)

view_data(img_data)

fname = 'test_ul_17'
save_8bit_image(fname, img_data)


#%% ül 18
import numpy as np
import matplotlib.pyplot as plt

n = 10
x = np.linspace(-2, 2, n)
y_orig = x ** 2
y = y_orig + 2 * np.random.rand(n) - 1  # Müra lisamine.

z = np.polyfit(x, y, 2) # Fitting.
pol = np.poly1d(z)      # Polynomial objekt.

plt.plot(x, y_orig, 'r+--', lw=0.7, label='Algne parabool')
plt.plot(x, y, 'ko--', label='Algne parabool + müra')
xp = np.linspace(x[0], x[-1], 70)  # Lisan punkte, et näeks pidevam välja.
plt.plot(xp, pol(xp), lw=2, label='VRM lähendatud parabool')

plt.xlabel('Argument $x$')
plt.ylabel('Funktsioon $f(x)$')
plt.legend(loc='upper center')
#plt.savefig('test.png', dpi=180)

plt.show()


#%% ül 19
import matplotlib.pyplot as plt
import numpy as np

plt.rcParams["figure.figsize"] = [5, 5]

n = 100_000
a = -0.31
b = 1.0

x0 = 11.0
y0 = 1.02

def F(x):
    return a*x + (2*(1 - a)*x**2) / (1 + x**2)

x = np.zeros(n)
y = np.zeros(n)

x[0], y[0] = x0, y0

for i in np.arange(n - 1):
    x[i+1] = b * y[i] + F(x[i])
    y[i+1] = -x[i] + F(x[i+1])

pos = np.sqrt(x**2 + y**2)
colors = pos / np.max(pos)

plt.plot(x, y, ',', label=f'$a = {a}$, $b = {b}$\n$x_0 = {x0}$, $y_0 = {y0}$')

plt.xlabel('$x$')
plt.ylabel('$y$')
plt.title('Gumowski-Mira fraktaal')
plt.legend(loc = 4)
#plt.savefig('test.png', dpi=300)

plt.show()

plt.rcParams.update(plt.rcParamsDefault)


#%% ül 20, Kasutades graafikutüüpi matplotlib.pyplot.scatter
import matplotlib.pyplot as plt
import numpy as np

plt.rcParams["figure.figsize"] = [5, 5]

n = 100_000
a = -0.31  # 0.31
b = 1.0

x0 = 11.0
y0 = 1.02

def F(x):
    return a * x + (2 * (1 - a) * x**2) / (1 + x**2)

x = np.zeros(n)
y = np.zeros(n)

x[0], y[0] = x0, y0

for i in range(n - 1):
    x[i+1] = b * y[i] + F(x[i])
    y[i+1] = -x[i] + F(x[i+1])

pos = np.sqrt(x**2 + y**2)
colors = pos / np.max(pos)

plt.scatter(x, y, 
            s=0.05, 
            c=colors, 
            marker='o', 
            cmap='twilight',
            label=f'$a = {a}$, $b = {b}$\n$x_0 = {x0}$, $y_0 = {y0}$')

plt.xlabel('$x$')
plt.ylabel('$y$')
plt.title('Gumowski-Mira fraktaal')
plt.legend(loc = 4)
#plt.savefig('test.png', dpi=300)

plt.show()

#print(plt.colormaps()) # Värvipalettide valik.
plt.rcParams.update(plt.rcParamsDefault)
















